function STA=Computeappearancesimilarity(labelledlevelvideo,numberofsuperpixelsperframe,concc,conrr,cim,mapped,thedepth,stsimilarities,temporaldepth,printonscreen, options, theoptiondata, filenames)

%paper options:
% options.stasqv=false; options.starefv=13; options.staavf=true;

%optimized options (default):
% options.stasqv=true; options.starefv=0.005; options.staavf=true; options.stalmbd=true;

if ( (~exist('temporaldepth','var')) || (isempty(temporaldepth)) )
    temporaldepth=2;
    %graphdepth used for stsimilarities is anyway the maximum temporal depth used
end
if ( (~exist('thedepth','var')) || (isempty(thedepth)) )
    thedepth=2;
end
if ( (~exist('printonscreen','var')) || (isempty(printonscreen)) )
    printonscreen=false;
end
printonscreeninsidefunction=false;
usecomplement=true;

noFrames=size(labelledlevelvideo,3);



%connectivity of stsimilarities is used to determine matches over-time,
%where to start building spatial neighbors from
[constrr,constcc]=Getconnectivityof(stsimilarities);



%labels for each frame at Level are stored as they are used several times
% labelledlevelvideo
% Transpose is actually unnecessary
% numberofsuperpixelsperframe=squeeze(max(max(labelledlevelvideo,[],1),[],2))';
% Level=1;
% allframelabels=cell(1,noFrames);
% numberofsuperpixelsperframe=zeros(1,noFrames);
% for f=1:noFrames
%     labels2 = bwlabel(ucm2{f} < Level);
%     allframelabels{f} = labels2(2:2:end, 2:2:end);
%     numberofsuperpixelsperframe(f)=max(allframelabels{f}(:));
%     Init_figure_no(6), imagesc(labels)
% end



% minL=0; maxL=100;
% minab=-86.1812575110439383; maxab=98.2351514395151639;
thelabs.l=cell(1,noFrames); thelabs.a=cell(1,noFrames); thelabs.b=cell(1,noFrames);
for f=1:noFrames
    [thelabs.l{f},thelabs.a{f},thelabs.b{f}] = Rgbtolab(cim{f});
%     thelabs.l{f}=thelabs.l{f}./(maxL-minL);
%     thelabs.a{f}=thelabs.a{f}./(maxab-minab);
%     thelabs.b{f}=thelabs.b{f}./(maxab-minab);
end



%Computation of all median colors and storage in array of the same size as mapped
allmedianl=zeros(size(mapped));
allmediana=zeros(size(mapped));
allmedianb=zeros(size(mapped));
for f=1:noFrames

    %compute median colors at the frame (or any other descriptor)
    for alabel=1:numberofsuperpixelsperframe(f)
        themask=(labelledlevelvideo(:,:,f)==alabel);
%         themask=(allframelabels{f}==alabel);
        
        allmedianl(f,alabel)=median(thelabs.l{f}(themask));
        allmediana(f,alabel)=median(thelabs.a{f}(themask));
        allmedianb(f,alabel)=median(thelabs.b{f}(themask));
        
    end
end
% Init_figure_no(6), imagesc(allmedianl)



[framebelong,labelsatframe,noallsuperpixels]=Getmappedframes(mapped);
maxnumberofsuperpixelsperframe=max(numberofsuperpixelsperframe);



% tic
% sxf=[];
% syf=[];
% svf=[];
% sxo=[];
% syo=[];
% svo=[];
averageconnectionthrough=4.8; averageconnectionsintra=4.8;
estimateintraterms=floor(noallsuperpixels+noallsuperpixels*(averageconnectionsintra^thedepth));
estimateinterterms=floor(estimateintraterms*(averageconnectionthrough^temporaldepth)/2);
sxf=zeros(estimateintraterms,1);
syf=zeros(estimateintraterms,1);
svf=zeros(estimateintraterms,1);
sxo=zeros(estimateinterterms,1);
syo=zeros(estimateinterterms,1);
svo=zeros(estimateinterterms,1);
noinsertedintra=0; noinsertedinter=0;
for f=1:noFrames
    spatf=find(framebelong==f);
    
    %the matrices accumulate the determined coefficient between the labels
    %at frame f and those at frames f:f+temporaldepth
    similarityatf=zeros(maxnumberofsuperpixelsperframe,maxnumberofsuperpixelsperframe); %symmetric matrix of sp at frame f
    similaritydonef=false(maxnumberofsuperpixelsperframe,maxnumberofsuperpixelsperframe); %at f neighbors may be considered multiple times
    similarityatothers=zeros(maxnumberofsuperpixelsperframe,maxnumberofsuperpixelsperframe,temporaldepth); %similarity between sp and those at other frames
    similaritydoneothers=false(maxnumberofsuperpixelsperframe,maxnumberofsuperpixelsperframe,temporaldepth); %used to extract data

    for asp=spatf %scan all superpixels at frame f
        %asp is in global labelling, localsp is in local labelling
        localsp=labelsatframe(asp);

        %the temporal connection are determined according to
        %stsimilarities, additionally only connecttions above a certain
        %threshold (minimum 1) can be considered
        tempneighlabels=constcc(constrr==asp); %global label
        tempneighlabels=[tempneighlabels;constrr(constcc==asp)]; %#ok<AGROW>

        %determine which frames these global labels correspond to
        tempneighframes=framebelong(tempneighlabels)';
        tempneighall=unique(tempneighframes);
        
        %include current frame
        tempneighall=[f;tempneighall]; %#ok<AGROW>
        %exclude frames out of bounds [f:f+temporaldepth]
        tempneighall( (tempneighall>(f+temporaldepth)) | (tempneighall<f) )=[];

        %process labels at each frame in the range
        for neighframe=tempneighall'
            if (neighframe==f)
                touchedlabels=asp;
            else
                touchedlabels=tempneighlabels(tempneighframes==neighframe);
            end

            neighlabels=Getneighborlabels(touchedlabels,concc,conrr,thedepth,printonscreeninsidefunction,labelledlevelvideo(:,:,neighframe),mapped);
%             neighlabels=Getneighborlabels(touchedlabels,concc,conrr,thedepth,printonscreeninsidefunction,allframelabels{neighframe},mapped);
            neighlabels=unique([touchedlabels;neighlabels]); %include touchedlabels in neighlabels (included already for thedepth>1)

            for nl=1:numel(neighlabels)
                neighlabel=neighlabels(nl);
                neighlocallabel=labelsatframe(neighlabel);

                if (neighframe==f) %symmetric case
                    if (similaritydonef(localsp,neighlocallabel))
                        continue;
                    end
                    
                    similarityatf(localsp,neighlocallabel)=...
                        ( (allmedianl(f,localsp)-allmedianl(f,neighlocallabel))^2 +...
                        (allmediana(f,localsp)-allmediana(f,neighlocallabel))^2 +...
                        (allmedianb(f,localsp)-allmedianb(f,neighlocallabel))^2 );
                    similarityatf(neighlocallabel,localsp)= similarityatf(localsp,neighlocallabel);

                    similaritydonef(localsp,neighlocallabel)=true;
                    similaritydonef(neighlocallabel,localsp)=true;
                else %between sp at f and all others at other frames
                    
                    similarityatothers(localsp,neighlocallabel,neighframe-f)=...
                        ( (allmedianl(f,localsp)-allmedianl(neighframe,neighlocallabel))^2 +...
                        (allmediana(f,localsp)-allmediana(neighframe,neighlocallabel))^2 +...
                        (allmedianb(f,localsp)-allmedianb(neighframe,neighlocallabel))^2 );
                    
                    similaritydoneothers(localsp,neighlocallabel,neighframe-f)=true;
                end
            end

        end
    end

    
    
    %complement the symmetry (neighbors are computed on f)
    if (usecomplement)
        for cf=1:min(noFrames-f,temporaldepth)
            spatf=find(framebelong==(cf+f));

            for asp=spatf %scan all superpixels at frame cf
                %asp is in global labelling, localsp is in local labelling
                localsp=labelsatframe(asp);

                %the temporal connection are determined according to
                %stsimilarities, additionally only connecttions above a certain
                %threshold (minimum 1) can be considered
                tempneighlabels=constcc(constrr==asp); %global label
                tempneighlabels=[tempneighlabels;constrr(constcc==asp)]; %#ok<AGROW>

                %determine which frames these global labels correspond to
                tempneighframes=framebelong(tempneighlabels)';

                %process labels at frame f
                touchedlabels=tempneighlabels(tempneighframes==f);

                neighlabels=Getneighborlabels(touchedlabels,concc,conrr,thedepth,printonscreeninsidefunction,labelledlevelvideo(:,:,f),mapped);
%                 neighlabels=Getneighborlabels(touchedlabels,concc,conrr,thedepth,printonscreeninsidefunction,allframelabels{f},mapped);
                neighlabels=unique([touchedlabels;neighlabels]); %include touchedlabels in neighlabels (included already for thedepth>1)

                for nl=1:numel(neighlabels)
                    neighlabel=neighlabels(nl);
                    neighlocallabel=labelsatframe(neighlabel);

                    %between sp at cf+f and sp at f
                    if (similaritydoneothers(neighlocallabel,localsp,cf))
                        continue;
                    end

                    similarityatothers(neighlocallabel,localsp,cf)=...
                        ( (allmedianl(cf+f,localsp)-allmedianl(f,neighlocallabel))^2 +...
                        (allmediana(cf+f,localsp)-allmediana(f,neighlocallabel))^2 +...
                        (allmedianb(cf+f,localsp)-allmedianb(f,neighlocallabel))^2 );

                    similaritydoneothers(neighlocallabel,localsp,cf)=true;
                end

            end
        end
    end
    
    
    %extraction from similarityatf (symmetric)
    [r,c]=find(similaritydonef);
    toinserthere=numel(r);
    if (toinserthere>0) %at least diagonal points must be non-null
        sxf(noinsertedintra+1:noinsertedintra+toinserthere)=mapped(f,r)';
        syf(noinsertedintra+1:noinsertedintra+toinserthere)=mapped(f,c)';
        svf(noinsertedintra+1:noinsertedintra+toinserthere)=similarityatf(sub2ind(size(similarityatf),r,c));
    end
    noinsertedintra=noinsertedintra+toinserthere;
    
    for ff=1:temporaldepth
        velocitysimilarityframesff=similarityatothers(:,:,ff);
        velocitysimilaritydoneframesff=similaritydoneothers(:,:,ff);
        [r,c]=find(velocitysimilaritydoneframesff);
        toinserthere=numel(r);
        if (toinserthere>0)
            sxo(noinsertedinter+1:noinsertedinter+toinserthere)=mapped(f,r)';
            syo(noinsertedinter+1:noinsertedinter+toinserthere)=mapped(ff+f,c)';
            svo(noinsertedinter+1:noinsertedinter+toinserthere)=velocitysimilarityframesff(sub2ind(size(velocitysimilarityframesff),r,c));
        end
        noinsertedinter=noinsertedinter+toinserthere;
    end
    
end
% toc
sxf(noinsertedintra+1:end)=[];
syf(noinsertedintra+1:end)=[];
svf(noinsertedintra+1:end)=[];
sxo(noinsertedinter+1:end)=[];
syo(noinsertedinter+1:end)=[];
svo(noinsertedinter+1:end)=[];
fprintf('STA ratio estimate of terms to inserted intra %f (%d,%d), inter %f (%d,%d)\n',...
    estimateintraterms/noinsertedintra,estimateintraterms,noinsertedintra,...
    estimateinterterms/noinsertedinter,estimateinterterms,noinsertedinter);

% themean=mean(svf);
% thestd=std(svf);
% themin=min(svf);
% themax=max(svf);
% themedian=median(svf);
% fprintf('At frame: min %.10f, max %.10f, mean %.10f, median %.10f, std %0.10f\n',themin,themax,themean,themedian,thestd)
% themean=mean(svo);
% thestd=std(svo);
% themin=min(svo);
% themax=max(svo);
% themedian=median(svo);
% fprintf('At other frames: min %.10f, max %.10f, mean %.10f, median %.10f, std %0.10f\n',themin,themax,themean,themedian,thestd)



% sx=[sxf;sxo;syo]; sy=[syf;syo;sxo]; sv=[svf;svo;svo];
% afullmatrix=false(noallsuperpixels);
% count=0;
% for i=1:numel(sx)
%     if (afullmatrix(sx(i),sy(i)))
%         count=count+1;
%         fprintf('Element %d (frame %d, local label %d) - element %d (frame %d, local label %d)\n',...
%             sx(i),framebelong(sx(i)),labelsatframe(sx(i)),sy(i),framebelong(sy(i)),labelsatframe(sy(i)) );
%     end
%     afullmatrix(sx(i),sy(i))=true;
% end
% fprintf('Double elememts %d\n',count);



STA=Getstafromindexedrawvalues([sxf;sxo;syo], [syf;syo;sxo], [svf;svo;svo], noallsuperpixels, options);

if (printonscreen)
    Init_figure_no(6); spy(STA(1:1000,1:1000));
    Init_figure_no(6); spy(STA);
    Spywithcolor(STA(1:1204,1:1204),6,mapped)
end



%Add data to paramter calibration directory
if ( (isfield(options,'calibratetheparameters')) && (~isempty(options.calibratetheparameters)) && (options.calibratetheparameters) )
    thiscase='sta';
    printonscreenincalibration=false;
    Addthisdataforparametercalibration([sxf;sxo;syo],[syf;syo;sxo],[svf;svo;svo],thiscase,theoptiondata,filenames,noallsuperpixels,printonscreenincalibration);
end






function Compare_with_velocitylargersimilarities(velocitylargersimilarities,STA) %#ok<DEFNU>

isequal(velocitylargersimilarities,STA)

isequal(full(velocitylargersimilarities)>0,full(STA)>0)

max(max(abs(full(velocitylargersimilarities)-full(STA))))





